--local L = AceLibrary("AceLocale-2.2"):new("Quartz_Procs")
--
--
--[[
* TODO: 
* added ability to change colors, also fix up the default colors a little better
* fix: some spells might not get removed because of different spellid's (because of ranks)
		(check spell name instead of spell id when removing?)
		if isAura remove by name (kinda doesnt work like i wanted)
		(hacky fix to remove by name added)

* warlock: insta shadowbolt, incinerate, lifetap buff, VW sacrifice shield, nether protection
* mage: mana shield, incanter's absorption, slowfall (self)
* hunter: feed pet, mend pet
* priest: 
--]]
--

local Quartz = Quartz
if Quartz:HasModule('Procs') then
	return
end

local QuartzCustomTimer = Quartz:NewModule('Procs', 'AceHook-2.1')
local self = QuartzCustomTimer

local m = Quartz:GetModule('Mirror')
local QP = Quartz:GetModule('Player')
local ex = m.ExternalTimers
local new, del = Quartz.new, Quartz.del

local db = Quartz:AcquireDBNamespace("Procs")

local _, curClass = UnitClass("player")
local procs_List
local spellsWatch = {}
local fproc
local tproc

procs_List = {
	Druid = {
		[48517] = { -- Wrath Eclipse
			--Eclipse
			name = GetSpellInfo(48517),
			-- Wrath + Eclipse
			displayname = GetSpellInfo(48461) .. " ".. GetSpellInfo(48517),
			color = {1, 0.5, 0}, -- orange-ish
			length = 15,
			cooldown = 30,
		},
		[48518] = { -- Starfire Eclipse
			--Eclipse
			name = GetSpellInfo(48518),
			-- Starfire + Eclipse		
			displayname = GetSpellInfo(48465) .. " ".. GetSpellInfo(48518),
			color = {0, 0.5, 1}, -- blue-ish
			length = 15,
			cooldown = 30,
		},
		[22812] = { -- Barkskin
			name = GetSpellInfo(22812),
			color = {0, 1, 0}, -- green
			length = 12,
		},
		[29166] = { -- Innervate
			name = GetSpellInfo(29166),
			color = {0, 0, 1}, -- blue
			length = 20,
		},
		[48391] = { -- Owklin Frenzy
			name = GetSpellInfo(48391),
			color = {0.7, 0.1, 0.1},
			length = 10,
		},
		[53198] = { -- StarFall (changed to isAura for different ranks)
			name = GetSpellInfo(53198),
			color = {0.125, 0.698, 0.686},
			--length = 10,
			expires = 0,
			isAura = true,
		},
		[33831] = { -- Force of Nature
			name = GetSpellInfo(33831),
			color = {0.871, 0.721, 0.529},
			length = 30,
		},
		[50334] = { -- Berserk
			name = GetSpellInfo(50334),
			color = {1, 0, 0}, -- red
			length = 15,
		},
		[50213] = { -- Tiger's Fury
			name = GetSpellInfo(50213),
			color = {1, 0, 0}, -- red
			length = 6,
		},
		[5229] = { -- Enrage
			name = GetSpellInfo(5229),
			color = {1, 0, 0}, -- red
			length = 10,
		},
		[22842] = { -- Frenzied Regen
			name = GetSpellInfo(22842),
			color = {0, 1, 0}, -- green
			length = 10,
		},
		[33357] = { -- Cat Dash
			name = GetSpellInfo(33357),
			color = {0, 1, 0}, -- green
			length = 15,
		},
		[64823] = { -- Elune's Wrath (Balance T8 4pc bonus proc)
			name = GetSpellInfo(64823),
			color = {0, 0, 1}, -- 
			length = 10,
		},
		[61336] = { -- Survival Instincts *untested*
			name = GetSpellInfo(61336),
			color = {1, 0, 0}, -- red
			length = 20,
		},
		
		[16870] = { -- Clearcasting (From Omen of Clarity) *untested*
			name = GetSpellInfo(16870),
			color = {0, 0, 1}, -- blue
			length = 15,
		},
		
		--Druid: Savage Roar
		[52610] = {
			name = GetSpellInfo(52610),
			color = {1, 0.5, 0}, -- orange-ish
			expires = 0, -- placeholder for expiration time (dont need to include length here)
			isAura = true,
		},
	},

	Mage = {
		[48108] = { -- Hot Streak
			name = GetSpellInfo(48108),
			length = 10,
			color = {1, 0, 0}, -- red
		},
		[54741] = { -- Firestarter
			name = GetSpellInfo(54741),
			length = 10,
			color = {1, 0, 0.5}, --purple-ish
		},
		[31643] = { -- Blazing Speed
			name = GetSpellInfo(31643),
			length = 8,
			color = {0, 1, 0}, -- green
		},
		[12042] = { -- Arcane Power
			name = GetSpellInfo(12042),
			--length = 15,
			color = {0, 0, 1}, -- 
			isAura = true,
			expires = 0,
		},
		[44401] = { -- Missile Barrage
			name = GetSpellInfo(44401),
			length = 15,
			color = {1, 0, 0.5}, --purple-ish
		},
		[55342] = { -- Mirror Image
			name = GetSpellInfo(55342),
			length = 30,
			color = {0, 0.5, 1}, -- blue-ish
		},
		[54648] = { -- Focus Magic (the buff you get when the other person crits)
					-- TODO: Seems to stay up almost constantly, really no need to include it?
			name = GetSpellInfo(54648),
			length = 10,
			color = {0, 0, 1}, -- 
		},	
		
		--Frost
		[12472] = { -- Icy Veins
			name = GetSpellInfo(12472),
			length = 20,
			color = {0, 0, 1}, -- 
		},
		[44544] = { -- Fingers of Frost
			name = GetSpellInfo(44544),
			length = 15,
			color = {0, 0, 1}, -- 
		},
		[31687] = { -- Water Elemental (TODO: a talent can increase the duration)
			name = GetSpellInfo(31687),
			length = 60,
			color = {0, 0, 1}, -- 
		},
		[43038] = { -- Ice Barrier
			name = GetSpellInfo(43038),
			length = 60,
			color = {0, 0, 1}, -- 
		},
		[45438] = { -- Ice Block
			name = GetSpellInfo(45438),
			length = 10,
			color = {0, 0, 1}, -- 
		},
		[41425] = { -- Hypothermia
			name = GetSpellInfo(41425),
			length = 30,
			color = {1, 0, 0}, -- red
		},
		[32612] = { -- Invisibility
			name = GetSpellInfo(32612),
			color = {0, 0, 1}, -- 
			isAura = true,
			expires = 0,
		},
		
		[64343] = { -- Impact (TODO: Temporary fix (this is unlimited but i made it 5 mins))
			name = GetSpellInfo(64343),
			color = {1, 0.5, 0}, -- orange-ish
			length = 300,
		},
		[57761] = { -- Fireball! (instant cast fireball)
			name = GetSpellInfo(57761),
			color = {1, 0, 0}, -- red
			length = 15,
		},
	},

	Rogue = {
		[63848] = { -- Hunger for Blood
			name = GetSpellInfo(63848),
			length = 60,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		[11305] = { -- Sprint
			name = GetSpellInfo(11305),
			length = 15,
			color = {0, 1, 0}, -- green
		},
		[13750] = { -- Adrenline Rush
			name = GetSpellInfo(13750),
			length = 15,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		[13877] = { -- Blade Flurry
			name = GetSpellInfo(13877),
			length = 15,
			color = {1, 0.5, 0}, -- orange-ish
		},
		[31224] = { -- Cloak of Shadows
			name = GetSpellInfo(31224),
			length = 5,
			color = {1, 0, 0.5}, --purple-ish
		},
		[26669] = { -- Evasion
			name = GetSpellInfo(26669),
			length = 15,
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
		},
		[36563] = { -- ShadowStep (dmg buff)
			name = GetSpellInfo(36563) .. " (dmg)",
			length = 10,
			color = {1, 0, 0.5}, --purple-ish
		},
		[36554] = { -- ShadowStep (speed)
			name = GetSpellInfo(36554) .. " (speed)",
			length = 3,
			color = {1, 0, 0.5}, --purple-ish
		},
		[26888] = { -- Vanish
			name = GetSpellInfo(26888),
			length = 10,
			color = {0.28, 0.24, 0.55}, -- darkslate blue
		},
		[51690] = { -- Killing Spree
			name = GetSpellInfo(51690),
			length = 2.5,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		[45182] = { -- Cheat Death *untested*
			name = GetSpellInfo(45182),
			length = 3,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		
		--Rogue: Slice and Dice (Rank 2)
		--(don't need rank 1 in here, it still catch it from the name from Rank2)
		[6774] = {
			name = GetSpellInfo(6774),
			color = {1, 0.5, 0}, -- orange-ish
			expires = 0,
			isAura = true,
		},
		--Rogue: Shadow Dance
		[51713] = { 
			name = GetSpellInfo(51713),
			color = {0.7, 0.1, 0.1}, -- red-ish
			expires = 0,
			isAura = true,
		},
	},

	Warrior = {
		[52437] = { -- Sudden Death
			name = GetSpellInfo(52437),
			length = 10,
			color = {0.7, 0.1, 0.1}, -- red-ish
		},
		[60503] = { -- Taste for Blood
			name = GetSpellInfo(60503),
			length = 9,
			color = {1, 0.5, 0}, -- orange-ish
		},
		[46924] = { -- Bladestorm
			name = GetSpellInfo(46924),
			length = 6,
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
		},
		[871] = { -- Shield Wall *untested*
			name = GetSpellInfo(871),
			color = {0.7, 0.1, 0.1}, -- red-ish
			length = 12,
		},
		[12975] = { -- Last Stand *untested*
			name = GetSpellInfo(12975),
			color = {0.7, 0.1, 0.1}, -- red-ish
			length = 20,
		},
	},
		
	Hunter = {
		[56453] = { -- Lock and Load
			name = "LnL",
			displayname = GetSpellInfo(56453),
			length = 12,
			cooldown = 30,
			color = {0, 0.5, 1}, -- blue-ish
		},
		[35099] = { -- Rapid Killing
			name = GetSpellInfo(35099),
			color = {1, 0, 0.5}, -- purple-ish
			length = 20,
		},
		[34692] = { -- Beast Within
			name = GetSpellInfo(34692),
			color = {1, 0, 0}, -- red
			expires = 0,
			isAura = true,
		},
		[3045] = { -- Rapid-Fire
			name = GetSpellInfo(3045),
			color = {0.7, 0.1, 0.1}, -- red-ish
			length = 15,
		},
		[19263] = { -- Deterrance
			name = GetSpellInfo(19263),
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
			length = 5,
		},
	},
	
	Warlock = {
		[18093] = { -- Pyroclasm
			name = GetSpellInfo(18093),
			length = 10,
			color = {1, 0, 0}, -- red
		},
		[47283] = { -- Empowered Imp
			name = GetSpellInfo(47283),
			length = 8,
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
		},
		[54277] = { -- Backdraft
			name = GetSpellInfo(54277),
			length = 15,
			color = {1, 0, 0.5}, --purple-ish
		},
		[63321] = { -- Life Tap (20% spirit glyph buff)
			name = GetSpellInfo(63321),
			length = 20,
			color = {0, 0.5, 1}, -- blue-ish
		},
	},
	
	Priest = {
		[33154] = { -- Surge of light
			name = GetSpellInfo(33154),
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
			expires = 0,
			isAura = true,
		},
		[33206] = { -- Pain Supression
			name = GetSpellInfo(33206),
			color = {0, 0.5, 1}, -- blue-ish
			expires = 0,
			isAura = true,
		},
		[10060] = { -- Power Infusion
			name = GetSpellInfo(10060),
			color = {1, 0, 0.5}, --purple-ish
			expires = 0,
			isAura = true,
		},
		[59000] = { -- Spirit Tap
			name = GetSpellInfo(59000),
			color = {1, 0.5, 0}, -- orange-ish
			expires = 0,
			isAura = true,
		},
		[6788] = { -- Weakened Soul (TODO: Fix: Doesnt work with pvp set bonus reduction)
			name = GetSpellInfo(6788),
			color = {1, 0, 0}, -- red
			length = 15,
		},
		[59891] = { -- Borrowed Time
			name = GetSpellInfo(59891),
			color = {1, 0.5, 0}, -- orange-ish
			length = 6,
		},
		[63944] = { -- Renewed Hope
			name = GetSpellInfo(63944),
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
			length = 20,
		},
	},
	
	DeathKnight = {
		[51124] = { -- Killing Machine
			name = GetSpellInfo(51124),
			color = {0.7, 0.1, 0.1}, -- red-ish
			length = 30,
		},
	},
	
	General = {
		[32182] = { -- Heroism
			name = GetSpellInfo(32182),
			length = 40,
			color = {1, 0.65, 0}, -- orange
		},
		[2825] = { -- Bloodlust (untested)
			name = GetSpellInfo(2825),
			length = 40,
			color = {1, 0.65, 0}, -- orange
		},
		
		--[[
		[59657] = { -- Argent Valor (test)
			name = "Argent Valor",
			length = 20,
			color = {1, 0, 0} -- red
		},
		
		
		[45544] = { -- First Aid (Rank 15)
			name = GetSpellInfo(45544),
			length = 8,
			color = {0, 1, 0}, --
		},
		[11196] = { -- Recently Bandaged
			name = GetSpellInfo(11196),
			length = 60,
			color = {1, 0, 0}, --
		},
		--]]
	}
	
}



function QuartzCustomTimer:OnInitialize()
	Quartz:RegisterDefaults("Procs", "profile", {
		active = true,
	})
end

function QuartzCustomTimer:OnEnable()
	if db.profile["active"] then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_AURA")
	end
end

function QuartzCustomTimer:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UnregisterEvent("UNIT_AURA")
end

function QuartzCustomTimer:Enable(doenable)
	if doenable then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_AURA")
	else
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:UnregisterEvent("UNIT_AURA")
	end
	db.profile["active"] = doenable
end


do
	function joinTables(t1, t2)
		local t3 = {}
		for k,v in pairs(t1) do
			table.insert(t3, k, v)
		end
		for k,v in pairs(t2) do
			table.insert(t3, k, v)
		end
		return t3
	end
	
	--Setup the spellsWatch value to hold current table for that class
	if (curClass == "DRUID") then
		spellsWatch = joinTables(procs_List.Druid, procs_List.General)
	elseif (curClass == "MAGE") then
		spellsWatch = joinTables(procs_List.Mage, procs_List.General)
	elseif (curClass == "ROGUE") then
		spellsWatch = joinTables(procs_List.Rogue, procs_List.General)
	elseif (curClass == "WARRIOR") then
		spellsWatch = joinTables(procs_List.Warrior, procs_List.General)
	elseif (curClass == "HUNTER") then
		spellsWatch = joinTables(procs_List.Hunter, procs_List.General)
	elseif (curClass == "WARLOCK") then
		spellsWatch = joinTables(procs_List.Warlock, procs_List.General)
	elseif (curClass == "PRIEST") then
		spellsWatch = joinTables(procs_List.Priest, procs_List.General)
	elseif (curClass == "DEATHKNIGHT") then
		spellsWatch = joinTables(procs_List.DeathKnight, procs_List.General)
	end
	
	
	function populateValues(table)
		--print("populateValues()")
		if not table then return end
		local list = {}
		for k, v in pairs(table) do
			--print("populateValues(): ".. v.name)
			list[k] = v.name
		end
		return list
	end
	
	local function set(field, value)
		if value ~= nil then
			db.profile[field] = value
		else
			db.profile[field] = false
		end
		--Quartz.ApplySettings()
	end
	local function get(field)
		if db.profile[field] ~= nil then
			return db.profile[field]
		else
			return true
		end
	end
	local function setcolor(field, ...)
		db.profile[field] = {...}
		--Quartz.ApplySettings()
	end
	local function getcolor(field)
		if db.profile[field] then
			return unpack(db.profile[field])
		elseif spellsWatch[tonumber(field)] then
			return spellsWatch[tonumber(field)].color
		else
			error(field.." is nil")
		end
	end
	
	--/new option code
	local spellargs = {}
	spellargs = {
		type='group',
		name = "Procs",
		desc = "Procs",
		args = {}
	}
	
	for k,v in pairs(procs_List) do
		
		spellargs.args[k] = {
			type = 'group',
			name = k,
			desc = k .. " Procs/Buffs/Abilities",
			args = {}
		}
		
		for spellid,spell in pairs(v) do
		
			spellargs.args[k].args[spellid] = {
				type = 'toggle',
				name = spell.displayname or spell.name,
				desc = 'Enable/Disable',
				get = get,
				set = set,
				--order = 50,
				passValue = spellid,
			}
			
		end
	end
	
	Quartz.options.args.Procs = spellargs
	--/new
	
	--/new option code
	--[[ WTF WONT THIS WORK!?
	Quartz.options.args.Procs = {
		type='group',
		name = "Procs",
		desc = "Procs",
		args = {
			spells = {
				type = 'multiselect',
				name = 'Show',
				desc = 'Select to show',
				get = function(_, key) return true end,
				set = function(_, key, value) db.profile[key] = value or nil end,
				values = populateValues(),
			},
		},
	}
	--]]
	--/new
	
end



function QuartzCustomTimer:createProcFrame(sID)
	fproc = CreateFrame("Frame", "ProcFrame", QP.castBarParent)
	fproc:Hide()
	fproc:SetFrameStrata("BACKGROUND")
	fproc:SetWidth(64)
	fproc:SetHeight(64)

	_,_,sIcon = GetSpellInfo(sID)
	tproc = fproc:CreateTexture("ProcTexture","BACKGROUND")
	tproc:SetTexture(sIcon)
	tproc:SetAllPoints(fproc)
	fproc.texture = tproc

	fproc:SetPoint("LEFT", 0, 0)
	fproc:Show()
end

function QuartzCustomTimer:createCustomTimer(sName, sLength, sID, sColor, isCooldown)
	if db.profile[sID] ~= nil then
		if (db.profile[sID] == true) then
			local sIcon = ''
			if (sID > 0) and (isCooldown == false) then
				_,_,sIcon = GetSpellInfo(sID)
			end
			
			ex[sName] = {
				startTime = GetTime(),
				endTime = GetTime() + sLength,
				icon = sIcon,
				color = sColor,
			}
			m:TriggerEvent("QuartzMirror_UpdateCustom")	
			
			--self:createProcFrame(sID)
		end
	else
		local sIcon = ''
		if (sID > 0) and (isCooldown == false) then
			_,_,sIcon = GetSpellInfo(sID)
		end
		
		ex[sName] = {
			startTime = GetTime(),
			endTime = GetTime() + sLength,
			icon = sIcon,
			color = sColor,
		}
		m:TriggerEvent("QuartzMirror_UpdateCustom")
		
		--self:createProcFrame(sID)
	end
end

-- Checks each buff when Aura changes
function QuartzCustomTimer:UNIT_AURA(unit)
	if unit ~= "player" then return end

	for i=1,40 do
		local name,rank,icon,count,dtype,dur,expr,caster,isStealable=UnitAura(unit,i)
		if name and dur and expr then
			--for k,v in pairs(procs_AuraSpells) do
			for k,v in pairs(spellsWatch) do
				if (v.isAura) and (name == v.name) then
					if (expr ~= v.expires) then -- create the timer						
						--print("Spell: '"..name.."' duration: "..dur.." expires in: "..(expr - GetTime()).." secs")						
						self:createCustomTimer(name, dur, k, v.color, false)
						v.expires = expr
					end
				end
			end				
		end
	end
end

function QuartzCustomTimer:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	if (destGUID == UnitGUID("player")) then --check if the player is receiving the buff
		local spellID = select(1,...)
		local spellname = select(2,...)
		
		if (event == "SPELL_AURA_APPLIED") or (event == "SPELL_AURA_REFRESH") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				-- Make sure it's not a spell that gets added in the UNIT_AURA event
				if (spellsWatch[spellID].isAura == nil) or (spellsWatch[spellID].isAura == false) then
					local d_name = spellsWatch[spellID].displayname or spellsWatch[spellID].name
					
					self:createCustomTimer(d_name, spellsWatch[spellID].length, spellID, spellsWatch[spellID].color, false)
					
					if (spellsWatch[spellID].cooldown) then
						local cd_name = spellsWatch[spellID].name or spellsWatch[spellID].displayname
						--TODO: translate this
						cd_name = cd_name .. " Cooldown"
						self:createCustomTimer(cd_name, spellsWatch[spellID].cooldown, spellID, {1,0,0}, true)
					end
				end
			end
			
		-- Use this to remove procs that can be consumed (or clicked off, or dispelled)
		elseif (event == "SPELL_AURA_REMOVED") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				local d_name = spellsWatch[spellID].name
				if ex[d_name] ~= nil then
					ex[d_name] = del(ex[d_name])
					m:TriggerEvent("QuartzMirror_UpdateCustom")
				end
			-- hacky fix to remove by name
			elseif (ex[spellname] ~= nil) then
				ex[spellname] = del(ex[spellname])
				m:TriggerEvent("QuartzMirror_UpdateCustom")
			end
		end
	end
	
end
